Index: lib/javascript-static.js
=========================================================
--- lib/javascript-static.js	(revision 1.77)
+++ lib/javascript-static.js	Fri Jul 24 22:01:46 WST 2009
@@ -560,7 +560,7 @@
             date_selector_calendar.currentowner.release_calendar();
         }
     }
-} 
+}
 
 date_selector_calendar.prototype.claim_calendar = function() {
     date_selector_calendar.cancel_any_timeout();
@@ -733,12 +733,15 @@
     return (arrReturnElements)
 }
 
-function openpopup(url, name, options, fullscreen) {
-    var fullurl = url;
-    if (!url.match(/https?:\/\//)) {
-        fullurl = moodle_cfg.wwwroot + url;
+function openpopup(event, args) {
+
+    YAHOO.util.Event.preventDefault(event);
+
+    var fullurl = args.url;
+    if (!args.url.match(/https?:\/\//)) {
+        fullurl = moodle_cfg.wwwroot + args.url;
     }
-    var windowobj = window.open(fullurl,name,options);
+    var windowobj = window.open(fullurl,args.name,args.options);
     if (!windowobj) {
         return true;
     }
@@ -812,7 +815,7 @@
         }
 
         // Make the request.
-        YAHOO.util.Connect.asyncRequest('GET', url, callback); 
+        YAHOO.util.Connect.asyncRequest('GET', url, callback);
     }
 }
 
@@ -886,7 +889,7 @@
 collapsible_region.prototype.userpref = null;
 
 /**
- * The key divs that make up this 
+ * The key divs that make up this
  * @property div, innerdiv, captiondiv
  * @type HTMLDivElement
  */
@@ -895,7 +898,7 @@
 collapsible_region.prototype.captiondiv = null;
 
 /**
- * The key divs that make up this 
+ * The key divs that make up this
  * @property icon
  * @type HTMLImageElement
  */
@@ -1102,3 +1105,113 @@
     }
     return list.join('&');
 }
+/**
+ * Finds all help icons on the page and initiates YUI tooltips for
+ * each of them, which load a truncated version of the help's content
+ * on-the-fly asynchronously
+ */
+function init_help_icons() {
+    // var logger = new YAHOO.widget.LogReader(document.body, {draggable: true});
+
+    var iconspans = YAHOO.util.Dom.getElementsByClassName('helplink', 'span');
+
+    var tooltip = new YAHOO.widget.Tooltip('help_icon_tooltip', {
+        context: iconspans,
+        showdelay: 100,
+        hidedelay: 150,
+        autodismissdelay: 50000,
+        underlay: 'none'
+    });
+
+    tooltip.contextTriggerEvent.subscribe(
+        function(type, args) {
+            // Fetch help page contents asynchronously
+            // Load spinner icon while content is loading
+            var spinner = document.createElement('img');
+            spinner.src = moodle_cfg.loadingicon;
+
+            this.cfg.setProperty('text', spinner);
+
+            var context = args[0];
+            context.title = '';
+
+            var link = context.getElementsByTagName('a')[0];
+            link.title = '';
+            YAHOO.util.Dom.getElementsByClassName('iconhelp', 'img', link)[0].title = '';
+            var thistooltip = this;
+            var ajaxurl = link.href + '&fortooltip=1';
+
+
+            var callback = {
+                success: function(o) {
+                    thistooltip.cfg.setProperty('text', o.responseText);
+                },
+                failure: function(o) {
+                    var debuginfo = o.statusText;
+                    if (moodle_cfg.developerdebug) {
+                        o.statusText += ' (' + ajaxurl + ')';
+                    }
+                    thistooltip.cfg.setProperty('text', debuginfo);
+                }
+            };
+
+            var conn = YAHOO.util.Connect.asyncRequest("get", ajaxurl, callback);
+        }
+    );
+}
+
+/**
+ * Prints a confirmation dialog in the style of DOM.confirm().
+ * @param object event A DOM event
+ * @param string message The message to show in the dialog
+ * @param string url The URL to forward to if YES is clicked. Disabled if fn is given
+ * @param function fn A JS function to run if YES is clicked.
+ */
+function confirmdialog(event, message) {
+
+    YAHOO.util.Event.preventDefault(event);
+    
+    var simpledialog = new YAHOO.widget.SimpleDialog('confirmdialog',
+        { width: '300px',
+          fixedcenter: true,
+          modal: true,
+          visible: false,
+          draggable: false
+        }
+    );
+    
+    simpledialog.setHeader(mstr.moodle.confirmation);
+    simpledialog.setBody(message);
+    simpledialog.cfg.setProperty('icon', YAHOO.widget.SimpleDialog.ICON_WARN);
+    
+    var handlecancel = function() {
+        this.hide();
+    };
+
+    var handleyes = function() {
+        this.hide();
+        var target = event.target;
+        
+        if (target.tagName == 'A') {
+            window.location = target.href;
+        } else if (target.tagName == 'INPUT') {
+            var parentelement = target.parentNode;
+            while (parentelement.tagName != 'FORM' && parentelement.tagName != 'BODY') {
+                parentelement = parentelement.parentNode;
+            }
+            if (parentelement.tagName == 'FORM') { 
+                parentelement.submit();
+            }
+        } else if(moodle_cfg.developerdebug) {
+            alert("Element of type " + target.tagName + " is not supported by the confirmdialog function. Use A or INPUT");
+        }
+    };
+    
+    var buttons = [ { text: mstr.moodle.cancel, handler: handlecancel, isDefault: true },
+                    { text: mstr.moodle.yes, handler: handleyes } ];
+    
+    simpledialog.cfg.queueProperty('buttons', buttons);
+    
+    simpledialog.render(document.body);
+    simpledialog.show();
+}
Index: lib/outputlib.php
=========================================================
--- lib/outputlib.php	(revision 1.46)
+++ lib/outputlib.php	Sat Jul 25 15:13:13 WST 2009
@@ -15,6 +15,13 @@
 // You should have received a copy of the GNU General Public License
 // along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
 
+/**
+ * This constant is used for html attributes which need to have an empty
+ * value and still be output by the renderers (e.g. alt="");
+ *
+ * @constant @EMPTY@
+ */
+define('HTML_ATTR_EMPTY', '@EMPTY@');
 
 /**
  * Functions for generating the HTML that Moodle should output.
@@ -27,7 +34,6 @@
  * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
  */
 
-
 /**
  * A renderer factory is just responsible for creating an appropriate renderer
  * for any given part of Moodle.
@@ -1306,7 +1312,9 @@
      */
     protected function output_attribute($name, $value) {
         $value = trim($value);
-        if ($value || is_numeric($value)) { // We want 0 to be output.
+        if ($value == HTML_ATTR_EMPTY) {
+            return ' ' . $name . '=""';
+        } else if ($value || is_numeric($value)) { // We want 0 to be output.
             return ' ' . $name . '="' . $value . '"';
         }
     }
@@ -2189,6 +2197,7 @@
 
         $this->page->set_state(moodle_page::STATE_DONE);
 
+
         return $output . $footer;
     }
 
@@ -2324,12 +2333,332 @@
         return $output;
     }
 
-    public function link_to_popup_window() {
+    /**
+     * Given a html_textarea object, outputs an <a> tag that uses the object's attributes.
+     *
+     * @param mixed $link A html_link object or a string URL (text param required in second case)
+     * @param string $text A descriptive text for the link. If $link is a html_link, this is not required.
+     * @return string HTML fragment
+     */
+    public function textarea($textarea) {
+
+    }
+
+    /**
+     * Given a html_link object, outputs an <a> tag that uses the object's attributes.
+     *
+     * @param mixed $link A html_link object or a string URL (text param required in second case)
+     * @param string $text A descriptive text for the link. If $link is a html_link, this is not required.
+     * @return string HTML fragment
+     */
+    public function link($link, $text=null) {
+        $attributes = array('href' => $link);
+
+        if (is_a($link, 'html_link')) {
+            $link->prepare();
+            $attributes['href'] = prepare_url($link->url);
+            $text = $link->text;
+
+            $attributes['class'] = $link->get_classes_string();
+            $attributes['title'] = $link->title;
+            $attributes['id'] = $link->id;
+
+        } else if (empty($text)) {
+            throw new coding_exception('$OUTPUT->link() must have a string as second parameter if the first param ($link) is a string');
+        }
+
+        return $this->output_tag('a', $attributes, $text);
+    }
+   
+   /**
+    * Print a message along with button choices for Continue/Cancel. Labels default to Yes(Continue)/No(Cancel)
+    * @param string $message The question to ask the user
+    * @param html_button $buttoncontinue The html_button component representing the Continue answer
+    * @param html_button $buttoncancel The html_button component representing the Cancel answer
+    * @return string HTML fragment
+    */
+    public function confirm($message, $buttoncontinue, $buttoncancel) {
+        if (empty($buttoncontinue->label)) {
+            $buttoncontinue->label = get_string('yes');
+        }
+        if (empty($buttoncancel->label)) {
+            $buttoncancel->label = get_string('no');
+        }
+
+        $output = $this->box_start('generalbox', 'notice');
+        $output .= $this->output_tag('p', array(), $message);
+        $output .= $this->output_tag('div', array('class' => 'buttons'), $this->button($buttoncontinue) . $this->button($buttoncancel));
+        $output .= $this->box_end();
+        return $output;
+    }
+
+    /**
+     * Given a html_button object, outputs an <input> tag within a form that uses the object's attributes.
+     *
+     * @param html_button $button A html_button object
+     * @param string $formid An optional XHTML id attribute
+     * @return string HTML fragment
+     */
+    public function button($button, $formid=null) {
+        $button->prepare();
+        $this->page->prepare_event_handlers($button);
+
+        $buttonattributes = array('class' => $button->get_classes_string(),
+                                  'type' => 'submit',
+                                  'value' => $button->label);
+
+        $buttonattributes['disabled'] = $button->disabled;
+
+        if (empty($button->title) && !empty($popup->title)) {
+            $buttonattributes['title'] = $popup->title;
+        } else {
+            $buttonattributes['title'] = $button->title;
+        }
+
+        if (!empty($button->id)) {
+            $buttonattributes['id'] = $button->id;
+        }
+
+        $form = new html_form();
+        $form->url = $button->url;
+        $form->method = $button->method;
+        $form->id = $formid;
+
+        $buttonoutput = $this->output_empty_tag('input', $buttonattributes);
+        return $this->button_form($form, $buttonoutput);
+    }
+
+    /**
+     * Given a html_form component and an optional rendered submit button,
+     * outputs a HTML form with correct divs and inputs and a single submit button.
+     * This doesn't render any other visible inputs. Use moodleforms for these.
+     * @param html_form $form A html_form instance
+     * @param string $submitbutton A custom submit button (already rendered)
+     * @return string HTML fragment
+     */
+    public function button_form($form, $submitbutton=null) {
+        $form->prepare();
+        $this->page->prepare_event_handlers($form);
+
+        if (empty($submitbutton)) {
+            $submitbutton = $this->output_empty_tag('input', array('type' => 'submit', 'value' => get_string('ok')));
+        }
+
+        $hiddenoutput = '';
+
+        foreach ($form->url->params() as $var => $val) {
+            $hiddenoutput .= $this->output_empty_tag('input', array('type' => 'hidden', 'name' => $var, 'value' => $val));
+        }
+
+        $formattributes = array('method' => $form->method, 'action' => prepare_url($form->url, true));
+
+        $formattributes['id'] = $form->id;
+
+        $divoutput = $this->output_tag('div', array(), $hiddenoutput . $submitbutton);
+        $formoutput = $this->output_tag('form', $formattributes, $divoutput);
+        $output = $this->output_tag('div', array('class' => 'singlebutton'), $formoutput);
+
+        return $output;
+    }
+
+    /**
+     * Given a action_icon object, outputs an image linking to an action (URL or AJAX).
+     *
+     * @param action_icon $icon An action_icon object
+     * @return string HTML fragment
+     */
+    public function action_icon($icon) {
+
+        $icon->prepare();
+
+        $this->page->prepare_event_handlers($icon);
+
+        $image = new html_image();
+        $image->id = $icon->id;
+        $image->src = $icon->src;
+        $image->alt = $icon->title;
+
+        if (empty($image->alt) && !empty($icon->linktext)) {
+            $image->alt = $icon->linktext;
+        } else if (empty($image->alt)) {
+            debugging('action_icon called without correct $icon->title or $icon->linktext param given, no alt for the image.', DEBUG_DEVELOPER);
+        }
+
+        $image->add_classes($icon->classes);
+
+        $imageoutput = $this->image($image);
+
+        if ($icon->linktext) {
+            $imageoutput .= $icon->linktext;
+        }
+
+        $link = new html_link();
+        $link->url = $icon->url;
+        $link->text = $imageoutput;
+
+        return $this->link($link);
+    }
+
+    /**
+     * Print a help icon.
+     *
+     * @param help_icon $helpicon A help_icon object, subclass of html_link
+     *
+     * @return string  HTML fragment
+     */
+    public function help_icon($icon) {
+        global $COURSE;
+
+        $icon->prepare();
+
+        $icon->link->add_action_object(new popup_action('click', $icon->link->url));
+
+        $image = null;
+
+        if (!empty($icon->image)) {
+            $image = $icon->image;
+            $image->add_class('iconhelp');
+        }
+
+        return $this->output_tag('span', array('class' => 'helplink'), $this->link_to_popup($icon->link, $image));
+    }
+
+    /**
+     * Creates and returns a button to a popup window
+     *
+     * @param html_link $link Subclass of moodle_html_component
+     * @param moodle_popup $popup A moodle_popup object
+     * @param html_image $image An optional image replacing the link text
+     *
+     * @return string HTML fragment
+     */
+    public function link_to_popup($link, $image=null) {
+        $link->prepare();
+
+        $this->page->prepare_event_handlers($link);
+
+        if (empty($link->url)) {
+            throw new coding_exception('Called $OUTPUT->link_to_popup($link) method without $link->url set.');
+        }
+
+        $linkurl = prepare_url($link->url);
+
+        $tagoptions = array(
+                'title' => $link->title,
+                'id' => $link->id,
+                'href' => ($linkurl) ? $linkurl : prepare_url($popup->url),
+                'class' => $link->get_classes_string());
+
+        // Use image if one is given
+        if (!empty($image) && $image instanceof html_image) {
+
+            if (empty($image->alt)) {
+                $image->alt = $link->text;
+            }
+
+            $link->text = $this->image($image);
+
+            if (!empty($link->linktext)) {
+                $link->text = "$link->title &nbsp; $link->text";
+            }
+        }
+
+        return $this->output_tag('a', $tagoptions, $link->text);
+    }
+
+    /**
+     * Creates and returns a spacer image with optional line break.
+     *
+     * @param html_image $image Subclass of moodle_html_component
+     *
+     * @return string HTML fragment
+     */
+    public function spacer($image) {
+        $image->prepare();
+        $image->add_class('spacer');
+
+        if (empty($image->src)) {
+            $image->src = $this->old_icon_url('spacer');
+        }
+
+        $output = $this->image($image);
+
+        return $output;
+    }
+
+    /**
+     * Creates and returns an image.
+     *
+     * @param html_image $image Subclass of moodle_html_component
+     *
+     * @return string HTML fragment
+     */
+    public function image($image) {
+        $image->prepare();
+
+        $attributes = array('class' => $image->get_classes_string(),
+                            'style' => prepare_legacy_width_and_height($image),
+                            'src' => prepare_url($image->src),
+                            'alt' => $image->alt,
+                            'title' => $image->title);
+
+        return $this->output_empty_tag('img', $attributes);
+    }
+
+    /**
+     * Print the specified user's avatar.
+     *
+     * This method can be used in two ways:
+     * <pre>
+     * // Option 1:
+     * $userpic = new user_picture();
+     * // Set properties of $userpic
+     * $OUTPUT->user_picture($userpic);
+     *
+     * // Option 2: (shortcut for simple cases)
+     * // $user has come from the DB and has fields id, picture, imagealt, firstname and lastname
+     * $OUTPUT->user_picture($user, $COURSE->id);
+     * </pre>
+     *
+     * @param object $userpic Object with at least fields id, picture, imagealt, firstname, lastname
+     *     If any of these are missing, or if a userid is passed, the database is queried. Avoid this
+     *     if at all possible, particularly for reports. It is very bad for performance.
+     *     A user_picture object is a better parameter.
+     * @param int $courseid courseid Used when constructing the link to the user's profile. Required if $userpic
+     *     is not a user_picture object
+     * @return string HTML fragment
+     */
+    public function user_picture($userpic, $courseid=null) {
+        // Instantiate a user_picture object if $user is not already one
+        if (!($userpic instanceof user_picture)) {
+            if (empty($courseid)) {
+                throw new coding_exception('Called $OUTPUT->user_picture with a $user object but no $courseid.');
+            }
 
+            $user = $userpic;
+            $userpic = new user_picture();
+            $userpic->user = $user;
+            $userpic->courseid = $courseid;
-    }
+        }
 
-    public function button_to_popup_window() {
+        $userpic->prepare();
+
+        $output = $this->image($userpic->image);
 
+        if (!empty($userpic->link) && !empty($userpic->url)) {
+            $actions = $userpic->get_actions();
+            if (!empty($actions)) {
+                $link = new html_link();
+                $link->url = $userpic->url;
+                $link->text = fullname($userpic->user);
+                $link->add_action_object($actions[0]);
+                $output = $this->link_to_popup($link);
+            } else {
+                $output = $this->link(prepare_url($userpic->url), $output);
+            }
+        }
+
+        return $output;
     }
 
     public function close_window_button($buttontext = null, $reloadopener = false) {
@@ -2506,8 +2835,55 @@
         if (!is_a($link, 'moodle_url')) {
             $link = new moodle_url($link);
         }
-        return $this->output_tag('div', array('class' => 'continuebutton'),
-                print_single_button($link->out(true), $link->params(), get_string('continue'), 'get', '', true));
+        $button = new html_button();
+        $button->url = $link;
+        $button->values = $link->params();
+        $button->label = get_string('continue');
+        $button->method = 'get';
+
+        return $this->output_tag('div', array('class' => 'continuebutton') , $this->button($button));
+    }
+
+    /**
+     * Print a continue button that goes to a particular URL.
+     *
+     * @param string|moodle_url $link The url the button goes to.
+     * @return string the HTML to output.
+     */
+    public function paging_bar($pagingbar) {
+        $output = '';
+
+        $pagingbar->prepare();
+
+        if ($pagingbar->totalcount > $pagingbar->perpage) {
+            $output .= get_string('page') . ':';
+
+            if (!empty($pagingbar->previouslink)) {
+                $output .= '&nbsp;(' . $this->link($pagingbar->previouslink) . ')&nbsp;';
+            }
+
+            if (!empty($pagingbar->firstlink)) {
+                $output .= '&nbsp;' . $this->link($pagingbar->firstlink) . '&nbsp;...';
+            }
+
+            foreach ($pagingbar->pagelinks as $link) {
+                if ($link instanceof html_link) {
+                    $output .= '&nbsp;&nbsp;' . $this->link($link);
+                } else {
+                    $output .= "&nbsp;&nbsp;$link";
+                }
+            }
+
+            if (!empty($pagingbar->lastlink)) {
+                $output .= '&nbsp;...' . $this->link($pagingbar->lastlink) . '&nbsp;';
+            }
+
+            if (!empty($pagingbar->nextlink)) {
+                $output .= '&nbsp;&nbsp;(' . $this->link($pagingbar->nextlink) . ')';
+            }
+        }
+
+        return $this->output_tag('div', array('class' => 'paging'), $output);
     }
 
     /**
@@ -2730,6 +3106,20 @@
      * @var array class names to add to this HTML element.
      */
     public $classes = array();
+    /**
+     * @var string $title The title attributes applicable to any XHTML element
+     */
+    public $title = '';
+    /**
+     * An optional array of component_action objects handling the action part of this component.
+     * @var array $actions
+     */
+    protected $actions = array();
+    /**
+     * This array of generated ids is kept static to avoid id collisions
+     * @var array $generated_ids
+     */
+    public static $generated_ids = array();
 
     /**
      * Ensure some class names are an array.
@@ -2807,6 +3197,59 @@
         }
     }
 
+    /**
+     * Adds a JS action to this component.
+     * Note: the JS function you write must have only two arguments: (string)event and (object|array)args
+     * If you want to add an instantiated component_action (or one of its subclasses), use $component->add_action_object($action)
+     *
+     * @param string $event a DOM event (click, mouseover etc.)
+     * @param string $jsfunction The name of the JS function to call
+     * @param array  $jsfunctionargs An optional array of JS arguments to pass to the function
+     * @return void
+     */
+    public function add_action($event, $jsfunction, $jsfunctionargs=array()) {
+        while (empty($this->id) || in_array($this->id, moodle_html_component::$generated_ids)) {
+            $this->generate_id();
+        }
+        $this->actions[] = new component_action($event, $jsfunction, $jsfunctionargs);
+    }
+
+    /**
+     * Adds an instantiated component_action to this component.
+     * Note: the JS function you write must have only two arguments: (string)event and (object|array)args
+     *
+     * @param component_action $action An instantiated component_action or one of its subclasses
+     * @return void
+     */
+    public function add_action_object($action) {
+        if (!($action instanceof component_action)) {
+            throw new coding_exception('moodle_html_component::add_action_object($action) only takes an instance of component_action.');
+        }
+
+        while (empty($this->id) && !in_array($this->id, moodle_html_component::$generated_ids)) {
+            $this->generate_id();
+        }
+        $this->actions[] = $action;
+    }
+
+    /**
+     * Internal method for generating a unique ID for the purpose of event handlers.
+     * @return void;
+     */
+    protected function generate_id() {
+        $this->id = get_class($this) . '-' . substr(sha1(microtime() * rand(0, 500)), 0, 5);
+        if (!in_array($this->id, moodle_html_component::$generated_ids)) {
+            moodle_html_component::$generated_ids[] = $this->id;
+        }
+    }
+
+    /**
+     * Returns the array of component_actions.
+     * @return array Component actions
+     */
+    public function get_actions() {
+        return $this->actions;
+    }
 }
 
 
